/*=======================================================================+
|             DEPARTAMENTO MECANICA UNIVERSIDADE AVEIRO                  |
|               Projecto Humanoide (PHUA - MODULROB)                     |
|                                                                        |
| Programadores:                                                         |
|              David Manuel Costa Gameiro          N:20281               |
|              Filipe Carvalho Mostardinha         N:22085               |
|                                                                        |
| Nome Ficheiro: MasterPrinc.c                                           |
|                                                                        |
|                            SOURCE FILE                                 |
+=======================================================================*/

// ESTA VERSO POSSUI UM BUG NO ARRANQUE DO SISTEMA:
// Por vezes o sistema executa movimentos bruscos para a posio zero.
// Para mais pormenores ver mdulo TRAJECTORY.

#include "pic2.h"
#include "trajectory.h"

void main(void)
{
    byte srv;
    byte i;

    // Inicializao das estruturas globais
    initGlobal();

    //inicializacao das configuracoes do SCU
    initPic();

    // Inicializao do Controlador
    initController();

    // Inicializao do gerador de trajectrias
    initTrajectory();

    for (;;)  {
        while (timeTick==0);
        timeTick=0;
/*
        for (srv=0; srv<N_SERVOS; ++srv)  {
            servoPos(actuators.servo[srv].position,srv);
        }
*/
        TESTPIN=1;
        
        // Aplicao de uma trajectria
        trajectory();

        // Actualizao dos actuadores
        controller();

        TESTPIN=0;

        // Verificao da ocorrncia de violao de Deadline
        if (timeTick)  sensors.sysStatus.deadlineError=true;
    }
}
