/*=======================================================================+
|             DEPARTAMENTO MECANICA UNIVERSIDADE AVEIRO                  |
|                                                                        |
| Programadores:                                                         |
|       		David Manuel Costa Gameiro          N:20281              |
|       		Filipe Carvalho Mostardinha         N:22085              |
|                                                                        |
| Data:  Segunda - 10/Maio/2004                                          |
|                                                                        |
| Nome Ficheiro: InitCan.h                                               |
|                                                                        |
|                            HEADER FILE                                 |
+=======================================================================*/

#ifndef _CAN_H
#define _CAN_H

#include "global.h"

/*------------------------------------------------------------+
|     void InitCan(byte HostID)                               |
|                                                             |
| Entrada: HostID - Identidade do MCU na rede                 |
|                                                             |
| Sadida: no possui valores de saida                         |
|                                                             |
| Objectivo: Inicializar a configuracao do Protocolo de       |
|           comunicacoes CAN, recorrendo as macros anteriores |
+------------------------------------------------------------*/

extern void initCan(void);

extern bool sendCanStatus(void);                    // Transmisso de uma mensagem de erro

extern bool sendCanMessage(byte index);             // Transmisso de uma mensagem CAN

extern bool receiveCanMessage(byte buffer);         // Recepo de uma mensagem CAN de um dos SCU

#endif
