//*******************************************************************************************
// SERVO.H
//
// Header file para incluir em programas que utilizem as funcoes definidas
// no ficheiro "servo.c"
//
// (c) Milton Ruas <a21824@alunos.det.ua.pt>
//     DETUA & DEMUA, Nov/2005
//*******************************************************************************************

#ifndef _PIC2_H
#define _PIC2_H

#include "servo.h"

#define TESTPIN 	PORTCbits.RC4	// Saida para teste do funcionamento do Timer2 (perodo de 5ms)
#define TESTPIN2    PORTCbits.RC5
#define TESTPIN3    PORTCbits.RC6
#define TESTPIN4    PORTCbits.RC7

// ***************
// Device Drivers
// ***************

// Inicializacoes relativas ao microcontrolador
// pos0  a posio inicial do servo (entre -90 e +90 graus)
//
extern void initPic(void);

#endif
