#ifndef _SERVO_H
#define _SERVO_H

#include "global.h"

#define K_FACTOR 100


// Calibrao dos servos
extern void calibration(void);

// Aplicao de uma nova velocidade a um servo
extern signed char servoRequest(signed char position, byte srv);

// Inicializao do Controlador
extern void initController(void);

// Execuo do controlador
extern void controller(void);

// Controlador dos sensores de Fora
extern void forceController(void);

#endif
